/*
======================================================================
Very simple mirror selection

www.Steelronin.com
Scott@steelronin.com
======================================================================
*/

scriptName = "Mirror v0.1.0";
copyright = "Copyright (c) 2004 Scott lange";

/*
version notes
v0.1.0 mirror rotation is very basic and probable wrong.
*/

@version 2.3
@warnings
@name SR_tester
//@name SR_Mirror
@script generic

hierarchyList;
x = 0;

generic
{
    // base input values

    c1 = 1;
    c2 = 1;
    c3 = 1;
    
    cAxis;
    cRotation;
    posX;
    posY;
    posZ;
    rotH;
    rotP;
    rotB;
    mirroredItems;
    
  
    // perform all processing here
    scene = Scene();
    selList = scene.getSelect();
   
    if(selList == nil)
    {
        error("<br>You must select something before performing this operation.");
        return;
    }
 
    // reverse selList order
    listcopy = selList;
    for(a=1;a<=size(listcopy);a++)
        selList[(size(listcopy)+1) - a]=listcopy[a];

    // interface
    reqbegin(scriptName);


    //define callback var

    c1 = ctlchoice("Mirror Axis",c1,@"X","Y","Z"@);
    c2 = ctlcheckbox("Rotation",1); 
    c3 = ctlcheckbox("Mirror Children",1); 
    if(!reqpost()) return;
    cAxis = getvalue(c1);
    cRotation = getvalue(c2);
    cChildren = getvalue(c3);

    reqend();
    

    
    
    // setup some variables

    t = Scene().currenttime;
    n = size(selList);
    i;
    s;
    
    // selection loop
    
  
    for(i = 1;i <= n;i++)
    {
    
        SelectItem(selList[i].id);
        if(cChildren == 1)
        {
            x = 0;
            findChildren(selList[i]);
            if(x > 1)
            {
                for(a = 1; a <= x;a++)   
                    mirroredItems[a] = hierarchyList[a];
            
                //SelectItem(selList[i].id);
                for(b = 1; b <= size(hierarchyList);b++)
                    mirror(hierarchyList[b],t,cAxis,cRotation);
            }
            else
                mirror(selList[i],t,cAxis,cRotation);
        }
        else
        {
            mirror(selList[i],t,cAxis,cRotation);
        }
    }

    // reselect items

    SelectItem(selList[1].id);
    for(n=2;n<=size(selList);n++)
       AddToSelection(selList[n].id);         
}


findChildren: rootObj
{
    hierarchyList[++x] = rootObj;
    childObj = rootObj.firstChild();

    while(childObj)
    {
        findChildren(childObj);
            childObj = rootObj.nextChild();
    }
}

mirror: mirroredItem,t,cAxis,cRotation
{
 
    SelectItem(mirroredItem.id);
    obj = mirroredItem;
    pos = obj.getPosition(t);
    rot = obj.getRotation(t);

    posX = pos.x;
    posY = pos.y;
    posZ = pos.z;
    rotH = rot.h;
    rotP = rot.p;
    rotB = rot.b;
    if(cAxis == 1)
        posX = -pos.x;
    if(cAxis == 2)
        posY = -pos.y;
    if(cAxis == 3)
        posZ = -pos.z;
    if(cRotation == 1)
    {
        if(cAxis == 1)
        {
            rotH = -rot.h;
            rotB = -rot.b;
        }
        if(cAxis == 2)
        {
            rotH = -rot.p;
            rotP = -rot.h;
        }
        if(cAxis == 3)
        {
            rotH = rot.b;
            rotB = rot.h;
        }
    }
    Position(posX,posY,posZ);
    Rotation(rotH,rotP,rotB);
}